#!/usr/bin/perl
# Just a simple sniffer script
#
# C0D3D by <<<Bytebeater>>>
#
# Last Update: 29.04.2002

use Net::PcapUtils;
use NetPacket::Ethernet qw(:strip);
use NetPacket::IP qw(:strip);
use NetPacket::TCP;
use Data::Hexdumper;
use Getopt::Std;

# Autoflush Output
$|=1;

# Are you root?
if($> != 0)
{
    die "You must be root...\n\n";
}

# Need help?
if($ARGV[0] eq "--help")
{
    die "Usage $0 [-i interface] [-X password sniffin] [-t telnet sniffin] [-f 'pcap filter'] [-x dump hex]\n\n";
}

# Read in parameter
getopts('i:f:tXx', \%args);

# Set Interface
if($args{'i'})
{
    $dev = $args{'i'};
}
else
{
    $dev = "eth0";
}


# Pcap Filter
if($args{'f'})
{
    $filter = $args{'f'};
}
else
{
    $filter = "tcp";
}

print "Start sniffin on device $dev...\n\n";

Net::PcapUtils::loop(\&sniffit,
	       	     PROMISC => 1,
		     FILTER => $filter,
	       	     DEV => $dev,
		     NUMPACKETS => -1) || die "There was an error!\n$!\n\n";





sub sniffit
{
    my ($args, $header, $packet) = @_;

    my $ip = NetPacket::IP->decode(eth_strip($packet));
    my $tcp = NetPacket::TCP->decode(ip_strip($ip->{data}));
#    my $dump = NetPacket::TCP->decode($ip->{data});
    my $dump = $tcp->{data};

# Print Payload in Hex?
if($args{'x'})
{
    unless($dump eq "")
    {
       $dump = Data::Hexdumper::Hexdump( data => $dump, format => "H" );
    }
}

# Normal sniffin
unless( $args{'X'} || $args{'t'})
{
    print "$ip->{src_ip}:$tcp->{src_port}  -->  $ip->{dest_ip}:$tcp->{dest_port}\n";
    print "$dump\n\n";
}

# Password snffin mode
if($args{'X'})
{
    if( ($dump =~ /PASS/) || ($dump =~ /USER/) || ($dump =~ /Username/) || ($dump =~ /password/) )
    {
	print "$ip->{src_ip}:$tcp->{src_port}  -->  $ip->{dest_ip}:$tcp->{dest_port}\n";
	print "$dump\n\n";
    }
}

# Telnet mode
if($args{'t'})
{
    if ( ( ($tcp->{dest_port} == 23) || ($tcp->{src_port} == 23) ) && ($dump ne "") )
    {
	print "$dump";
    }
}
}
