#!/usr/bin/perl
#
# GUI Wrapper to start the GUI version of the single projects
#
# Programmed by Bastian Ballmann [ bytebeater@crazydj.de ]
# http://www.crazydj.de
#
# Last Update: 12.05.2002
#
# Licensed uder the GPL

use Tk;

###[ MAIN PART ]###

# Hauptfenster
$top = MainWindow->new();
$top->title('P.A.T.H  --  Perl Advanced TCP Hijacking');
$top->configure(background => 'black', foreground => 'green', borderwidth => 2);

# Frames
$inhalt = $top->Frame->pack(side => 'top', pady => 10, padx => 10);
$inhalt->configure(background => 'black', foreground => 'green');

$toolbar = $top->Frame->pack(side => 'bottom', pady => 10, padx => 10);
$toolbar->configure(background => 'black', foreground => 'green', borderwidth => 2);


# Menu
$menu = $top->Menu(type => 'Menubar');
$menu->configure(background => 'black', border => 1);
$conf = $menu->cascade('-label' => 'Tools');
$conf->configure(foreground => 'green',
		 background => 'black',
		 activebackground => 'black',
		 activeforeground => 'red');

$conf->command('-label' => 'Packetgenerator',
	       foreground => 'green',
	       background => 'black',
	       activebackground => 'black',
	       activeforeground => 'red',
	       command => [\&start,"/usr/bin/perl -I$ENV{PWD}/IP-Packet/ $ENV{PWD}/IP-Packet/ip-packet.pl"]);

$conf->command('-label' => 'RST Deamon',
	        foreground => 'green',
	        background => 'black',
	       activebackground => 'black',
	       activeforeground => 'red',
		command => [\&start,"/usr/bin/perl -I$ENV{PWD}/easterrst/ $ENV{PWD}/easterrst/easterrst.pl --gui"]);

$conf->command('-label' => 'Sniffer',
	        foreground => 'green',
	        background => 'black',
	       activebackground => 'black',
	       activeforeground => 'red',
		command => [\&start,"$ENV{PWD}/crazysniffer/crazysniffer.pl"]);

$conf->command('-label' => 'Quit',
	        foreground => 'green',
	        background => 'black',
	       activebackground => 'black',
	       activeforeground => 'red',
		command => sub { exit(0); });

$about = $menu->cascade('-label' => 'About');
$about->configure(foreground => 'green',
		  background => 'black',
	          activebackground => 'black',
	          activeforeground => 'red');

$about->command('-label' => 'About that tool',
	         foreground => 'green',
		 background => 'black',
		activebackground => 'black',
		activeforeground => 'red',
		 command => \&about);

$about->command('-label' => 'Heeelp me',
		foreground => 'green',
		background => 'black',
	       activebackground => 'black',
	       activeforeground => 'red',
		command => \&help);

$top->configure(-menu => $menu, border => 1);



# Lables
$inhalt->Label(text => 'P.A.T.H  --  Perl Advanced TCP Hijacking',
	       background => 'black',
	       foreground => 'green',
	       border => 0)->pack(side => 'top', pady => 5);

$inhalt->Label(text => 'The Hijackers P.A.T.H to galaxy',
	       background => 'black',
	       foreground => 'green',
	       border => 0)->pack(side => 'top', pady => 5);

$inhalt->Label(text => '------------------------------------------------------',
		background => 'black',
		foreground => 'grey',
		border => 1)->pack(side => 'top');

# Buttons

$toolbar->Button(text => 'Packetgenerator',
		 background => 'black',
		 foreground => 'green',
		 activebackground => 'black',
		 activeforeground => 'red',
		 borderwidth => 0,
		 border => 0,
		 command => [\&start,"/usr/bin/perl -I$ENV{PWD}/IP-Packet/ $ENV{PWD}/IP-Packet/ip-packet.pl"] )->pack(side => 'left', padx => 3, pady => 5);

$toolbar->Button(text => 'RST Daemon',
		 background => 'black',
		 foreground => 'green',
		 activebackground => 'black',
		 activeforeground => 'red',
		 borderwidth => 0,
		 border => 0,
		 command => [\&start,"/usr/bin/perl -I$ENV{PWD}/easterrst/ $ENV{PWD}/easterrst/easterrst.pl --gui"] )->pack(side => 'left', padx => 3, pady => 5);

$toolbar->Button(text => 'Sniffer',
		 background => 'black',
		 foreground => 'green',
		 activebackground => 'black',
		 activeforeground => 'red',
		 borderwidth => 0,
		 border => 0,
		 command => [\&start,"$ENV{PWD}/crazysniffer/crazysniffer.pl"] )->pack(side => 'left', padx => 3, pady => 5);

MainLoop();



###[ Subroutines ]###

# Start a tool using a child process
sub start
{
    my $tool = shift;

    # Fork a child process
    $pid = fork();
    die "Cannot fork a child process!\n$!\n" unless defined $pid;

    if($pid == 0)
    {
	print "[Child $$]: Starting $tool\n";
	system("$tool");
    }
}


# About dialog
sub about
{
    $aboutwin = $top->Toplevel;
    $aboutwin->title('About this nice t00l');
    $aboutwin->configure(background => 'black', foreground => 'red');

    $info = $aboutwin->Label(text => 'P.A.T.H.  --  Perl Advanced TCP Hijacking',
			     background => 'black',
			     foreground => 'red',
			     border => 0)->pack(pady => 5);

    $info2 = $aboutwin->Label(text => 'Programmed by Stefan Krecher and Bastian Ballmann',
			     background => 'black',
			     foreground => 'red',
			     border => 0)->pack(padx => 10);

    $info3 = $aboutwin->Label(text => 'Chaos Computer Club',
			     background => 'black',
			     foreground => 'red',
			     border => 0)->pack(padx => 10);

    $info4 = $aboutwin->Label(text => 'Last Update 12.05.2002',
			     background => 'black',
			     foreground => 'red',
			     border => 0)->pack(pady => 5);

    $downtown = $aboutwin->Frame()->pack(pady => 20);
$closebtn = $downtown->Button(text => 'Just close it!',
			      background => 'black',
			      foreground => 'green',
			      activebackground => 'black',
			      activeforeground => 'red',
			      borderwidth => 5,
			      command => sub { destroy $aboutwin})->pack();
}



sub help
{
    $helpwin = $top->Toplevel;
    $helpwin->title('Dont got r00t?? :-p');
    $helpwin->configure(foreground => 'red', background => 'black');
    $help1 = $helpwin->Label(text => 'Please look into the readme file of each tool!',
			     background => 'black',
			     foreground => 'red',
			     border => 0)->pack(pady => 5);

    $help2 = $helpwin->Label(text => 'Files can also be found here: http://p-a-t-h.sourceforge.net',
			     background => 'black',
			     foreground => 'red',
			     border => 0)->pack(padx => 10);

    $suckdown = $helpwin->Frame()->pack(pady => 20);
$scriptkiddie = $suckdown->Button(text => 'Close',
				  background => 'black',
				  foreground => 'green',
				  activebackground => 'black',
				  activeforeground => 'red',
				  borderwidth => 5,
				  command => sub { destroy $helpwin })->pack();
}

